/********************************************************************
 ANIM.C - Animation control for Models
*********************************************************************/

	
#include "engine.h"


/*
 Returns true if wrap
*/
int Anim_Loop(AnimSequence *anim,int *pframe,int *ptime)
{
	if ((*pframe)<anim->first||(*pframe)>anim->last) {
		*pframe=anim->first;
		*ptime=TotalTicks+10;
	}
	else {
		if ((*ptime)<=TotalTicks) {
			(*ptime)=TotalTicks+10;
			(*pframe)++;
			if ((*pframe)>anim->last) {
				*pframe=anim->first;
				return 1;
			}
		}
	}
	return 0;
}

int Object_Anim_Loop(AnimSequence *anim,Object *obj)
{
	return(Anim_Loop(anim,&obj->pob.frame,&obj->next_frame_tick));
//	return 0;
}

void Anim_Make(AnimSequence *anim,MDL *mdl,char *name)
{
	anim->first=MDL_FirstFrame(mdl,name);
	anim->last=MDL_LastFrame(mdl,name);
}

int IsAnimSequence(AnimSequence *anim,int frame)
{
	if (frame>=anim->first&&frame<=anim->last) return 1;
	return 0;
}

