/********************************************************************
 ENTITY.C - Entity management
*********************************************************************/

#include "engine.h"
#include "progs\progs.h"





void Entity_NewWorld(BSP *bsp)
{
	Player *p=Players;
	char *obj_params, *prog_name;
	int i, prog_idx, idx;

// Setup all the players in the game
	for(i=0;i<NumPlayers;i++,p++) {
		p->obj_idx=World_AddObject(PROG_PLAYER,NULL);
		Entity_PlayerStartCoords(&WorldBSP,Objects[p->obj_idx].pob.c);
		World_ObjectMoved(p->obj_idx);
	}


// Init the entities
	for(i=0;i<bsp->NumEntities;i++) {
		obj_params=bsp->Entities[i];
		prog_name=Parse_GetKeyValue(obj_params,"classname");
	// Got classname for the entity
		if (prog_name) {
			prog_idx=Prog_GetProgByName(prog_name);
		// We support the entity
			if (prog_idx>=0) {
				idx=World_AddObject(prog_idx,obj_params);
				World_ObjectMoved(idx);
			}
		// Replace all items with PROG_TEST
			else if (strncmp(prog_name,"ite",3)==0) {
				idx=World_AddObject(PROG_TEST,obj_params);
				World_ObjectMoved(idx);
			}
		}
	}

}



void Entity_PlayerStartCoords(BSP *bsp,float *p)
{
	char *prog_name, *origin;
	int i;

	for(i=0;i<bsp->NumEntities;i++) {
		prog_name=Parse_GetKeyValue(bsp->Entities[i],"classname");
		if (prog_name&&strcmp(prog_name,"info_player_start")==0) {
			origin=Parse_GetKeyValue(bsp->Entities[i],"origin");
			sscanf(origin,"%f %f %f",p,p+1,p+2);
			p[2]+=0.01;
			return;
		}
	}
	for (i=0;i<3;i++) p[i]=0;
}





/********************************************************************
  Quake entity lexical scanner
*********************************************************************/

static char buf_value[1024];


char *GetToken(char *start_ptr,char *token);


/*
 Returns: value as string or NULL if key is not found
*/
char *Parse_GetKeyValue(char *obj_params, char *key)
{
	char *ptr;
	char buf_key[32];

	ptr=obj_params;
	while(ptr) {
		ptr=GetToken(ptr,buf_key);
		if (ptr) {
			ptr=GetToken(ptr,buf_value);
			if (strcmp(key,buf_key)==0)
				return buf_value;
		}
	}
	return NULL;
}


/*
 Returns ptr to the next char after the token.
 If '}' is found, returns NULL.
*/
char *GetToken(char *start_ptr,char *token)
{
	char c;

// Find first  '"'
	while((*start_ptr)!='\"'&&(*start_ptr)!='}'&&(*start_ptr)!='\0')
		start_ptr++;
	if (start_ptr=='}'||start_ptr=='\0') return NULL;

// Advance ptr past '"'
	start_ptr++;

// Copy token from buffer to 'token' until '"' or '}' or NULL
	while(1) {
		c=*start_ptr; start_ptr++;
		if (c=='"') break;
		if (c=='}'||c=='\0') {
			start_ptr=NULL;
			break;
		}
		*token=c;
		token++;
	}
	*token='\0';
	return(start_ptr);
}
