

enum { NDEV_COM1=1, NDEV_COM2, NDEV_COM3, NDEV_COM4, NDEV_IPX, NUM_NDEVS };


typedef struct {
	int  device;		// 1-4 - com ports, 5 - ipx
	byte address[6];	// 6 byte ipx node address
	int  size;		// size of the packet data
} PktInfo;

/*
 Initialize a network device.
	For Com ports: param1 - socket (id word), param2 - baud rate
 	For IPX: param1 - socket
 Returns: non-zero if device has been inited
*/
int  Net_InitDevice(int device, int param1, int param2);

/*
 Shuts down all initialized net devices.
*/
void Net_ShutAllDevices(void);

/*
 Send a packet. PktInfo has to be filled out.
	pkt->device  - device to send the packet with
	pkt->address - address to send to (no use with com ports)
	pkt->size    - size of the packet
	buffer       - ptr to the data
 Returns non-zero if sent.
*/
int Net_SendPacket(PktInfo *pkt,void *buffer);

/*
 Get a packet from a given device. Before the call:
	pkt->device - device to get the acket from
	pkt->size   - size of the buffer (max size of the packet)
 If a packet has been received:
	pkt->address - address of the sender (no use with com ports)
	pkt->size    - size of the packet data
 Returns: non-zero if a packet has been read.
*/
int  Net_GetPacket(PktInfo *pkt,void *buffer);


