/********************************************************************
 Sound wrapper for the Poly Engine.
*********************************************************************/


/*
 Init the sound system. 
 Returns: non-zero if ok
*/
int  SND_Init(void);

/*
 Load sound sample from a file. 
 Returns: sample handle or -1 on error
*/
int  SND_LoadSample(char *fname);

/*
 Free sound sample
*/
void SND_FreeSample(int sample_idx);

/*
 Shutdown the sound system.
*/
void SND_Shut(void);

/*
 Play a sound sample.
 Returns: sound idx or -1 on error
*/
int  SND_PlaySample(int sample_idx,float volume,float panning);


/*
 Stop playing sound sample with given index.
*/
void SND_StopSample(int snd_idx);


/*
 Play a sound sample in 3D.
 Returns: sound idx or -1 on error
*/
int  SND_PlaySample3D(int sample_idx,float volume,float *coord);


/*
 Set listener position and orientation
*/
void SND_SetListener(float *coord,float *dir, float *up);

