
#include "engine.h"

#define MAX_PARTICLES		10000

static Particle Particles[MAX_PARTICLES];
static Particle *firstFree;

Particle *firstActive;



void InitParticles(void)
{
	int i;

	firstActive=0;

	firstFree=&Particles[0];
	for(i=0;i<MAX_PARTICLES-1;i++)
		Particles[i].next=&Particles[i+1];
	Particles[i].next=0;
}

void UpdateParticles(void) 
{
	Particle **prev_next=&firstActive, *p=firstActive;
	float delta[3], ticks=(float)FrameTicks, frame, count, ticks_per_frame;

	while(p) {

		frame=(int)p->ramp_frame;
		ticks_per_frame=(int)p->ticks_per_frame;
		count=(int)p->ticks_accum;
		count+=ticks;
		while(frame>=0&&count>ticks_per_frame) {
			frame--;
			count-=ticks_per_frame;
		}

	// Particle has expired
		if (frame<0) {
			*prev_next=p->next;
			p->next=firstFree;
			firstFree=p;
			p=*prev_next;
			continue;
		}

		p->ramp_frame=(byte)frame;
		p->ticks_accum=(byte)count;

	// Update position, color etc
		FVec_MulScalar(p->speed,ticks,delta);
		FVec_AddFVec(p->c,delta,p->c);

	// Go to the next particle
		prev_next=&p->next;
		p=p->next;
	}
}


Particle *AllocParticles(int num) 
{
	Particle *start=firstFree, *p=firstFree;

	while(num>1&&p&&p->next) {
		num--;
		p=p->next;
	}

	if (p) {
		firstFree=p->next;
		p->next=firstActive;
		firstActive=start;
	}

	return start;
}
