
/*
 Each ramp entry is four bytes: RGBI, where RGB is the color for
 true color rendering and I is index in the global palette for
 paletted rasterization.
*/

typedef struct _Particle {
	byte  type;
	byte  ramp_frame;
	byte  ticks_per_frame;
	byte  ticks_accum;
	byte *ramp;
	float c[3];
	float speed[3];
	struct _Particle *next;
} Particle;

extern Particle *firstActive;

void InitParticles(void);
void UpdateParticles(void);
void RenderParticles(void);


// This should be used only to create new particle effects
Particle *AllocParticles(int num);
