/********************************************************************
 CL_OVER.C - Camera overlays
*********************************************************************/

#include "..\engine.h"
#include "..\render.h"


extern void Particles_MakeSplash(float *c);


//extern int DoCameraSync;
extern int do_atmo;

static int shot_inited=0;
static AnimSequence 
		shot_carry,		// Carrying position
		shot_shoot;		// Shooting shotgun

static MDL   over1;
static int   over1a_frame;
static int   over1a_time;
//static float over1a_pos[3]={0,0,-2};
static float over1a_pos[3]={0,0,0};


void Atmo_Init(void);
void Atmo_Render(Camera *C);



void Overlay_Render(Camera *C)
{
	float bpitch,broll,byaw;
	POB pob={-1,{0,0,0},0,0,0};

	float backup_c[3], zpos[3]={0,0,0};


	if (!shot_inited) {
	// Force model loading
		if (!MDL_Load(&over1,"models/weapons/v_launch/tris.md2"))
			return;
	// Setup frames
		Anim_Make(&shot_carry,&over1,"idle");
		Anim_Make(&shot_shoot,&over1,"pow");
		shot_shoot.first++;
	// Start with carrying
//		over1a_frame=MDL_FirstFrame(&over1,"idle");
		Anim_Loop(&shot_carry,&over1a_frame,&over1a_time);
		Atmo_Init();
		shot_inited=1;
	}

// Update frames
	if (IsAnimSequence(&shot_shoot,over1a_frame)) {
		if (Anim_Loop(&shot_shoot,&over1a_frame,&over1a_time))
			Anim_Loop(&shot_carry,&over1a_frame,&over1a_time);
	}
	else {
		if (over1a_frame!=shot_carry.first||rand()<128)
			Anim_Loop(&shot_carry,&over1a_frame,&over1a_time);
	}


//	if (!DoCameraSync) return;

// Render gun
	FVec_Copy(C->c,pob.c);
	pob.angle=C->yaw;
	pob.vangle=C->pitch+PI/2;
	pob.frame=over1a_frame;
	render->drawMDL(&over1,&pob);

// Render atmospheric effects
	if (do_atmo)
		Atmo_Render(C);
}

void Overlay_Attack(void)
{
	if (!IsAnimSequence(&shot_shoot,over1a_frame))
		Anim_Loop(&shot_shoot,&over1a_frame,&over1a_time);
}




#define MAX_RAIN	1000

static Particle rain[MAX_RAIN];
static byte rain_ramp[] = {
	64,64,64,0
};


void Atmo_Init(void) 
{
	int i;
	for(i=0;i<MAX_RAIN;i++) {
		rain[i].ramp=rain_ramp;
		rain[i].ramp_frame=0;
		rain[i].ticks_per_frame=0;
		rain[i].ticks_accum=0;
		if (i<MAX_RAIN-1) 
			rain[i].next=&rain[i+1];
	}
	rain[MAX_RAIN-1].next=0;
}




void Atmo_Render(Camera *C)
{
	Particle *p=rain;
	int count=MAX_RAIN,i;
	float delta[3], ticks=(float)FrameTicks, minz;

	minz=C->c[2]-30.0f;

	while(count>0) {
		p->c[2]-=20.0f;
		if (p->c[2]<=minz) {
			p->c[2]=minz;
			Particles_MakeSplash(p->c);

			for(i=0;i<2;i++) {
				p->c[i]=C->c[i]+(float)((rand()&255)-128);
			}
			p->c[i]=C->c[i]+(float)(rand()&255);
		}

		count--;
		p++;
	}

	render->drawParticles(rain,PARTICLE_LINE);
}
