/********************************************************************
 PORTAL.C - AreaPortal stuff
*********************************************************************/

	
#include "..\engine.h"
#include "progs.h"

#include <windows.h>




typedef struct {
	int portal_idx;
} local_vars;

int Portal_Init(int obj_idx,char *params) 
{
	Object *o=&Objects[obj_idx];
	local_vars *vars=(local_vars *)o->vars;
	float dist;
	char *val;

// No params - should not happen
	if (!params) return 1;

// Find portal idx
	val=Parse_GetKeyValue(params,"style");
	if (!val) return 1;

	sscanf(val,"%d",&vars->portal_idx);

	if (vars->portal_idx<0||vars->portal_idx>=WorldBSP.NumPortals)
		return 1;

// Setup target-name (tag by which the door will be open)
	val=Parse_GetKeyValue(params,"targetname");
	if (val) o->tag=Tag_Register(val);

	return 0;
}


int Portal_Event(int obj_idx, int event, int param1, int param2) 
{
	Object *o=&Objects[obj_idx];
	local_vars *vars=(local_vars *)o->vars;
	char str[64];

	switch(event) {
		case PE_TAG:
/*			sprintf(str,"Portal: %d %d\n",vars->portal_idx,param2);
			MessageBox(NULL,str,"info",MB_OK);
*/			WorldBSP.Portals[vars->portal_idx].is_open=param2;
			break;
	}

	return 0;
}



void Portal_Process(POB *pob) {}
void Portal_Render(POB *pob) {}
void Portal_Free(void) {}


/********************************************************************
			REGISTRATION
*********************************************************************/

void Portal_Register(Prog *p)
{
	strcpy(p->prog_name,"func_areaportal");
	p->flags=	0;
	p->init=	Portal_Init;
	p->event=	Portal_Event;
	p->process=	Portal_Process;
	p->render=	Portal_Render;
	p->free=	Portal_Free;
}
