
/********************************************************************
			UTILITY CODE FOR PROGS
*********************************************************************/



#include "..\engine.h"
#include "progs.h"



void Shoot_Bullet(int obj_idx)
{
	FMatrix M;
	Object *obj=&Objects[obj_idx], *o;
	float delta[3]={0,1,0},coord[3],dir[3],angle;
	int i,idx;

// Make xform matrix for bullet in world coords
	FMatrix_Identity(M);
	i=GetPlayerFromObject(obj_idx);

	angle=obj->pob.angle;
	if (i>=0) angle+=Players[i].head_yaw;
//	angle+=(0.5-(float)(rand())/32767.0)*PI/4;
	FMatrix_PreZRot(M,angle);

	angle=0;
	if (i>=0) angle+=Players[i].head_pitch;
//	angle+=(0.5-(float)(rand())/32767.0)*PI/4;
	FMatrix_PreXRot(M,angle);

// Do collision-detection
	FMatrix_MulFVec(M,delta,dir);
	FVec_Copy(obj->pob.c,coord);
	coord[2]+=16;
	idx=CheckRay(&WorldBSP,coord,dir,obj_idx);

// Did the bullet hurt somebody?
	if (idx>=0) Prog_Event(idx,PE_HURT,obj_idx,1);

// Move away a bit
	FVec_MulScalar(dir,-16.0,delta);
	FVec_AddFVec(coord,delta,coord);

// Add explosion object
	o=&Objects[World_AddObject(PROG_EXPLOSION,NULL)];
	FVec_Copy(coord,o->pob.c);
}


void Shoot_Fireball(int obj_idx)
{
	FMatrix M, M_speed;
	Object *obj=&Objects[obj_idx], *o;
	float delta[3],coord[3], dir[3]={0,1,0}, speed[3];
	float yaw, pitch;
	char params[32];
	int i;

// Make xform matrix for bullet in world coords
	FMatrix_Identity(M);
	FMatrix_Identity(M_speed);

	i=GetPlayerFromObject(obj_idx);

	yaw=obj->pob.angle;
	if (i>=0) yaw+=Players[i].head_yaw;
//	yaw+=(0.5-(float)(rand())/32767.0)*PI/4;
	FMatrix_PreZRot(M,yaw);

	pitch=0;
	if (i>=0) pitch+=Players[i].head_pitch;
//	pitch+=(0.5-(float)(rand())/32767.0)*PI/4;
	FMatrix_PreXRot(M,pitch);
	FMatrix_PreXRot(M_speed,pitch);

// Make speed vector
	FMatrix_MulFVec(M_speed,dir,speed);

// Make start coords
	FVec_MulScalar(dir,16,dir);
	dir[0]+=6;
	FMatrix_MulFVec(M,dir,delta);
	FVec_Copy(obj->pob.c,coord);
	coord[2]+=10;
	FVec_AddFVec(coord,delta,coord);

// Add explosion object
	sprintf(params,"\"shooter\" \"%d\"",obj_idx);
	o=&Objects[World_AddObject(PROG_MISSILE,params)];
	FVec_Copy(coord,o->pob.c);
	o->pob.angle=yaw;
	o->pob.vangle=pitch;

	FVec_MulScalar(speed,8,speed);
	FVec_Copy(speed,o->speed);
}



