

// Setup constants (for init(int flags) call)

#define R_DOUBLE_BUFFER		1
#define R_WINDOWED		2
#define R_VBE			2
#define R_NO_VR_WAIT		4


// Values returned by getFlags()

#define R_TEXTURES_POW2			1
#define R_TEXTURES_32BIT		2


// Particle types

#define PARTICLE_DOT	0
#define PARTICLE_LINE	1


// This data is provided by the main program to the renderer

typedef struct {
	HINSTANCE hInstance;
	byte *Palette;
	int  *Paused;
	int  *Done;
	int  *LightMode;
	int  *DebugMode;
} RenderImport;

// This functions are provided by the renderer DLL

typedef struct {

	HWND (*init)(int width,int height,int flags);
	void (*shut)(void);
	void (*beginFrame)(Camera *C);
	void (*endFrame)(void);

	int  (*getScrWidth)(void);
	int  (*getScrHeight)(void);

	int  (*getFlags)(void);

	void (*addDLight)(float *coord,float *rgb,float intensity,float radius);

	void (*beginBSP)(BSP *bsp);
	void (*drawBSPModel)(POB *pob);
	void (*endBSP)(void);

	void (*drawMDL)(MDL *mdl, POB *pob);

	void (*drawSPR)(SPR *spr, POB *pob);

	void (*drawParticles)(Particle *p, int type);

} RenderExport;


/**
 This is the only function exported by Renderer DLL

 RenderExport *GetRender(RenderImport *rimp);

*/


extern RenderExport *render;
