
#include <windows.h>
#include <GL\gl.h>
#include <GL\glu.h>
#include <ddraw.h>
#include "..\engine.h"
#include "..\render.h"


// Support for OGL extensions

enum {

// Point-parameters
#ifndef GL_EXT_point_parameters
	#define GL_EXT_point_parameters		1
	GL_POINT_SIZE_MIN_EXT				= 0x8126,
	GL_POINT_SIZE_MAX_EXT				= 0x8127,
	GL_POINT_FADE_THRESHOLD_SIZE_EXT	= 0x8128,
	GL_DISTANCE_ATTENUATION_EXT			= 0x8129,
#endif


};

typedef void (APIENTRY *glPointParameterfEXT_t)(GLenum pname,GLfloat param);
typedef void (APIENTRY *glPointParameterfvEXT_t)(GLenum pname,GLfloat *params);


extern int flag_point_parameters;
extern glPointParameterfEXT_t  roglPointParameterfEXT;
extern glPointParameterfvEXT_t roglPointParameterfvEXT;




#define WM_SYNCACQUIRE      (WM_USER + 0)       // Acquire message

#define LMAP_SIDE			8
#define LMAP_SIDE2			3
#define LMAP_SIZE			(LMAP_SIDE<<4)
#define LMAP_SIZE2			(LMAP_SIDE2+4)
#define MAX_LMAP_BANKS		(100*65536/(LMAP_SIZE*LMAP_SIZE))
#define LMAP_FACES			(LMAP_SIDE*LMAP_SIDE)
#define LMAP_FACES2			(LMAP_SIDE2+LMAP_SIDE2)

extern byte *TexPalette;
extern int *pLightMode, *pDebugMode;

extern Camera *ccam;
extern BSP *cbsp;

extern int NumVisDLights;


// Functions for exporting

HWND GL_Init(int width,int height,int flags);
void GL_Shut(void);
void GL_BeginFrame(Camera *C);
void GL_EndFrame(void);
int  GL_GetScrWidth(void);
int  GL_GetScrHeight(void);
int  GL_GetFlags(void);
void GL_AddDLight(float *coord,float *rgb,float intensity,float radius);
void GL_BeginBSP(BSP *bsp);
void GL_DrawBSPModel(POB *pob);
void GL_EndBSP(void);
void GL_DrawMDL(MDL *mdl, POB *pob);
void GL_DrawSPR(SPR *spr, POB *pob);
void GL_DrawParticles(Particle *p, int type);


// Setup GL extensions
void InitGLExtensions(void);

// Texture management

void InitGLTextures(void);

void Tex_SetModelSkin(MDL *mdl,int skin_idx);
void Tex_SetSpriteSkin(SPR *spr,int frame_idx);

void Tex_PreCacheBSPTextures(void);

void Tex_SetBSPLightmapBank(int bank);
int  Tex_IsDynamicLightmap(int face_idx);
void Tex_BeginDynamicLighting(void);
void Tex_SetDynamicLightmap(int face_idx);

void Tex_SetBSPTexture(int tex_idx);

void Tex_SetSkyTexture(int idx);



