
#include "rogl.h"


void GL_DrawSPR(SPR *spr,POB *pob) 
{
	SPRFrame *frame=&spr->Frames[pob->frame];
	float glm[16], vup[3], vr[3], c[3], temp[3];

// Get gl xform matrix
	glGetFloatv(GL_MODELVIEW_MATRIX,glm);

// Up vector
	vup[0]=glm[0];
	vup[1]=glm[4];
	vup[2]=glm[8];

// Right vector
	vr[0]=glm[1];
	vr[1]=glm[5];
	vr[2]=glm[9];

// Draw the sprite
	glTranslatef(pob->c[0],pob->c[1],pob->c[2]);	

	Tex_SetSpriteSkin(spr,pob->frame);

	//glEnable(GL_ALPHA_TEST);
	//glAlphaFunc(GL_GREATER, 0.5f);


	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glBegin(GL_QUADS);

	//glColor4f(1.0, 1.0, 1.0, 1.0);

	FVec_MulScalar(vr,-frame->origin_x,temp);
	FVec_MulScalar(vup,-frame->origin_y,c);
	FVec_AddFVec(c,temp,c);
	glTexCoord2f(0,1);
	glVertex3fv(c);

	FVec_MulScalar(vr,frame->width-frame->origin_x,temp);
	FVec_MulScalar(vup,-frame->origin_y,c);
	FVec_AddFVec(c,temp,c);
	glTexCoord2f(0,0);
	glVertex3fv(c);

	FVec_MulScalar(vr,frame->width-frame->origin_x,temp);
	FVec_MulScalar(vup,frame->height-frame->origin_y,c);
	FVec_AddFVec(c,temp,c);
	glTexCoord2f(1,0);
	glVertex3fv(c);

	FVec_MulScalar(vr,-frame->origin_x,temp);
	FVec_MulScalar(vup,frame->height-frame->origin_y,c);
	FVec_AddFVec(c,temp,c);
	glTexCoord2f(1,1);
	glVertex3fv(c);

	glEnd();

	glTranslatef(-pob->c[0],-pob->c[1],-pob->c[2]);

	glDisable(GL_BLEND);
	//glDisable(GL_ALPHA_TEST);
}
