	.586P

include pr_inc.inc

	public _BlitFlatSurf_asm

	.DATA

align 4

;fixed_scale	dd 65536.0
;fixed16_scale	dd 8192.0
zbuf_scale	dd 131072.0
delta_z		dd ?
delta_z2	dd ?
coord_z		dd ?
color_4		dd 02020202h
span_buf_offset	dd ?
temp		dd ?


	.CODE
align 4

_BlitFlatSurf_asm proc near

	push eax
	push ebx
	push ecx
	push edx
	push esi
	push edi
	push ebp
;	sub esp, local_vars_size	; not going to use push/pop

	mov edi, _pr_surf


; ONCE PER SURFACE (FLAT)
; Find delta_z for zfill and dest_ptr for tex blit and color_4
;  edi - ptr to surface
;  eax, esi - making color_4
;  ecx - dest_ptr
;  ebx, edx - delta_z2

	fld zbuf_scale		;  s
	fmul [edi].zi		;sdzx
	mov eax, _pr_color
	mov ah, al
	fistp delta_z		;
	mov edx, delta_z	;
	mov ebx, delta_z	;
	shl edx, 17		;
	mov esi, eax
	shl bx, 1
	add edx, ebx		;
	shl eax, 16
	mov [delta_z2], edx	;
	add eax, esi
	mov [color_4], eax



				; st0  st1  st2  st3  st4  st5  st6  st7


	mov esi, [edi].FirstSpan
;	or esi, esi
;	jz surf_end

span_start:

; Restore surface pointer
	mov edi, _pr_surf

; At this point: 
;	ESI - ptr to span
;	EDI - ptr to surf


; Find tex 1/Z (float), zbuf 1/Z (fixed), span_buf_offset, zbuf ptr
	fild [esi].spanY	;  y
	fild [esi].spanX	;  x    y

	mov ebx, [esi].spanX
	mov eax, [esi].spanY

	fmul [edi].zi		; cx    y
	fxch st(1)		;  y   cx
	fmul [edi].zj		; cy   cx
	fxch st(1)		; cx   cy
	fadd [edi].zc		;zc+cx cy

	add ebx, _pr_buf_offset
	mov edi, _ZBuffer

	mul _gfxScrWidth

	mov ecx, [esi].spanCount
	add eax, ebx

	faddp st(1), st		; 1/Z
	fld zbuf_scale		;  s   1/Z

	lea edi, [edi+eax*2]
	mov [span_buf_offset], eax

	fmul st,st(1)		;s1/Z  1/Z
	fxch st(1)		; 1/Z  s1/Z

	fstp temp		; s1/Z
	fistp coord_z

	mov eax, coord_z


; At this point: 
;	ESI - ptr to span
;	EDI - zbuf ptr
;	EAX - 1/Z value
;	ECX - count

	mov edx, delta_z

	test edi, 3
	jz process_aligned_z
	mov [edi], ax
	dec ecx
	add edi, 2
	add eax, edx

process_aligned_z:
	mov ebp, ecx
	shr ecx, 1
	or ecx, ecx
	jz last_pixel_z

	mov ebx, eax
	add eax, edx
	shl eax, 16
	mov edx, delta_z2
	add eax, ebx

fillz_loop:
	mov [edi], eax
	add edi, 4
	add eax, edx
	dec ecx
	jnz fillz_loop

last_pixel_z:
	test ebp, 1
	jz end_fillz
	mov [edi], ax

end_fillz:



; At this point
;	ESI - ptr to span

; Find ptr for blitting destination, color and count
	mov eax, span_buf_offset
	mov edi, _gfxBuffer
	mov ecx, [esi].spanCount;
	add edi, eax
	mov eax, color_4

	or ecx, ecx
	jz span_end


; At this point
;	ESI - ptr to span
;	EDI - ptr to buffer
; 	ECX - byte count
;	EAX - four-byte color

	test edi, 3		; test for dword alignment
	jz process_aligned

; Process mis-aligned bytes
	mov edx, edi
	and edx, 3
	mov ebx, ecx
	add ebx, edx
	cmp ebx, 4
	jge process_mis_long

; special case, very small span
	rep stosb
	jmp span_end

; misaligned beginning of a long span
process_mis_long:
	mov ebx, ecx
	mov ecx, 4
	sub ecx, edx
	sub ebx, ecx
	rep stosb
	mov ecx, ebx


process_aligned:
	mov edx, ecx
	shr ecx, 2
	and edx, 3

; At this point: 
;	ESI - ptr to span
;	EDI - ptr to buffer
;	ECX - four-byte counter
;	EDX - leftover pixels
;	EAX - four-byte color 

	or ecx, ecx
	jz leftover_pixels

; main dword blitting loop
	cld
	rep stosd

leftover_pixels:		; read dword, change, write dword
	mov ecx, edx
	rep stosb

span_end:
	mov esi, [esi].spanNext;
	or esi, esi
	jnz span_start


surf_end:

;	add esp, local_vars_size
	pop ebp
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax

        ret
_BlitFlatSurf_asm endp

end
