
/********************************************************************
			RENDER.C
*********************************************************************/

extern byte  *gfxBuffer;
extern short *ZBuffer;


/********************************************************************
			SURF.C
*********************************************************************/

void InitSurfCache(void);
void ShutSurfCache(void);
int  GetSurf(int face_idx,int mip,byte **ptr,int *width,int *height);


/********************************************************************
			PR_POLY.C
*********************************************************************/

#define SKYBOX_SIZE		10000.0


void PR_BeginFrame(void);
void PR_EndFrame(void);

void PR_BeginBSPFace(void);
void PR_AddBSPEdge(int edge_idx,int v1_idx,int v2_idx);
void PR_EndBSPFace(int face_idx);

void PR_BeginSkyFace(void);
void PR_AddSkyEdge(float *p1, float *p2);
void PR_EndSkyFace(int side_idx,float *u,float *v,float *n);


typedef struct _ScrSpan {
	int x, y, count;
	struct _ScrSpan *Next;
} ScrSpan;

typedef struct _ScrSurf {
	float ui,uj,uc;
	float vi,vj,vc;
	float zi,zj,zc;
	ScrSpan *FirstSpan;

//	miptex_t *texture;
	int face_idx;
	int mip_level;

	int x_start;
	int state;
	struct _ScrSurf *Prev, *Next;
} ScrSurf;


/*
 Global variables to pass params from PR to Blitter.
*/
extern ScrSurf *pr_surf;	// Surface to blit
extern int pr_buf_offset;	// Offset in the output buffer/zbuffer
extern byte *pr_tex;		// Texture (from surface cache)
extern int pr_tex_width;	// Texture width
extern int pr_mask_u, pr_mask_v;// Texture size masks (for sky, water etc)
extern int pr_color;		// For flat blitter


/*
 Span blitters for the PolyRenderer (PR)
*/
void BlitFlatSurf(void);
void BlitPerfectTexSurf(void);
void BlitTexSurf(void);
void BlitSkySurf(void);

void BlitFlatSurf_asm(void);
void BlitTex16Surf_asm(void);

