	.586P


include pr_inc.inc
include tx16loop.inc



	public _BlitTex16Surf_asm

	.DATA

align 4

flRunLength	dd 16.0
delta_a		dd ?		; texmap deltas
delta_b		dd ?
delta_c		dd ?
delta_a16	dd ?
delta_b16	dd ?
delta_c16	dd ?

zbuf_scale	dd 131072.0
delta_z		dd ?		; zbuf stuff
delta_z2	dd ?
coord_z		dd ?

u_fixed		dd ?		; tex coords and deltas
du_fixed	dd ?
v_fixed		dd ?
dv_fixed	dd ?

delta_carry	dd ?
delta_nocarry	dd ?
tex_delta	equ delta_nocarry
du_frac		dd ?
dv_frac		dd ?


dest_ptr	dd ?		; dest for blit for the span
span_buf_offset	dd ?		; offset for start of the span (buf/zbuf)
temp		dd ?		; temp val for fp

FixedOne	dd 65536.0

inv_run		dd 0.0		; cannot happen
;		dd 0.0		; special case, 1-pix prerun
		dd 1.0 		; 2	(1/1)
		dd 0.5		; 3	(1/2)
		dd 0.33333333	; 4	(1/3)
		dd 0.25		; 5	(1/4)
		dd 0.2		; 6	(1/5)
		dd 0.16666667	; 7	(1/6)
		dd 0.14285714	; 8	(1/7)
		dd 0.125	; 9	(1/8)
		dd 0.11111111	; 10	(1/9)
		dd 0.1		; 11	(1/10)
		dd 0.09090909	; 12	(1/11)
		dd 0.08333333	; 13	(1/12)
		dd 0.07692308	; 14	(1/13)
		dd 0.07142857	; 15	(1/14)
		dd 0.06666667	; 16	(1/15)
		dd 0.0625

span_ptr	dd ?
run_count	dd ?




	.CODE

align 4

_BlitTex16Surf_asm proc near

	push eax
	push ebx
	push ecx
	push edx
	push esi
	push edi
	push ebp
;	sub esp, local_vars_size	; not going to use push/pop

	mov edi, _pr_surf

; ONCE PER SURFACE (TEX 16-pix)
; Find delta_z(2) for zfill, dest_ptr for tex blit, setup
; deltas for a,b,c
;  edi - ptr to surface
;  ecx - dest_ptr
;  ebx, edx - delta_z2
				; st0  st1  st2  st3  st4  st5  st6  st7

	fld [edi].ui		; ui  
	fld [edi].vi		; vi   ui  
	fld [edi].zi		; zi   vi   ui  
	fld [zbuf_scale]	; s    zi   vi   ui  
	fmul st,st(1)		;sdzx  zi   vi   ui  

	mov eax, [edi].ui
	fistp [delta_z]		; zi   vi   ui  

	mov [delta_a], eax

	fmul [flRunLength]	; dc16 vi   ui  
	fxch st(1)		; vi   dc16 ui  
	fmul [flRunLength]	; db16 dc16 ui  
	mov edx, [delta_z]	;
	mov ebx, [delta_z]	;
	fxch st(2)		; ui   dc16 db16
	fmul [flRunLength]	; da16 dc16 db16
	fxch st(2)		; db16 dc16 da16
	fstp [delta_b16]	; dc16 da16
	fstp [delta_c16]	; da16
	fstp [delta_a16]	;

	shl edx, 17		;
	mov eax, [edi].vi
	shl bx, 1
	mov ecx, [edi].zi
	add edx, ebx		;
	mov [delta_b], eax
	mov [delta_c], ecx
	mov [delta_z2], edx	;

	mov esi, [edi].FirstSpan

; ***********************   SPAN START   *************************

span_start:

; Restore surface pointer
	mov edi, _pr_surf

; At this point: 
;	ESI - ptr to span
;	EDI - ptr to surf


; Find tex a,b,c (float), zbuf 1/Z (fixed), zbuf ptr
				; st0  st1  st2  st3  st4  st5  st6  st7

	fild [esi].spanY	; y
	fild [esi].spanX	; x    y

	mov ebx, [esi].spanX
	mov eax, [esi].spanY

	fld [edi].vj		; vj   x    y
	fld [edi].vi		; vi   vj   x    y
	fmul st,st(2)		; vix  vj   x    y
	fxch st(1)		; vj   vix  x    y
	fmul st,st(3)		; vjy  vix  x    y
	fxch st(1)		; vix  vjy  x    y
	fadd [edi].vc		; vc   vjy  x    y
	fxch st(3)		; y    vjy  x    vc
	fld [edi].uj		; uj   y    vjy  x    vc
	fmul st,st(1)		; ujy  y    vjy  x    vc
	fxch st(2)		; vjy  y    ujy  x    vc
	faddp st(4), st		; y    ujy  x    B
	fxch st(1);		; ujy  y    x    B
	fadd [edi].uc		; uc   y    x    B
	fxch st(2)		; x    y    uc   B
	fld [edi].ui		; ui   x    y    uc   B
	fmul st,st(1)		; uix  x    y    uc   B
	faddp st(3), st		; x    y    A    B

	fmul [edi].zi		; zix  y    A    B
	fxch st(1)		;  y   zix  A    B
	fmul [edi].zj		; zjy  zix  A    B
	fxch st(1)		; zix  zjy  A    B
	fadd [edi].zc		; zc   zjy  A    B

	add ebx, _pr_buf_offset
	mov edi, _ZBuffer

	mul _gfxScrWidth	; TODO: Take this away!!!
	add eax, ebx

	mov [span_buf_offset], eax
	lea edi, [edi+eax*2]

	faddp st(1), st		; C    A    B
	fld zbuf_scale		; s    C    A    B
	fmul st,st(1)		; s1/Z C    A    B
	fistp coord_z		; C    A    B


; Start computing 1/c for left-most pixel
	fld [FixedOne]		; 1    c    a    b
	fdiv st,st(1)		; 1/c  c    a    b


; *********************   Z-BUFFER BLIT   ************************

; At this point: 
;	ESI - ptr to span
;	EDI - zbuf ptr

	mov ecx, [esi].spanCount
	mov eax, coord_z
	mov edx, delta_z

	test edi, 3
	jz process_aligned_z
	mov [edi], ax
	dec ecx
	add edi, 2
	add eax, edx

process_aligned_z:
	mov ebp, ecx
	shr ecx, 1
	or ecx, ecx
	jz last_pixel_z

	mov ebx, eax
	add eax, edx
	shl eax, 16
	mov edx, delta_z2
	add eax, ebx

fillz_loop:
	mov [edi], eax
	add edi, 4
	add eax, edx
	dec ecx
	jnz fillz_loop

last_pixel_z:
	test ebp, 1
	jz end_fillz
	mov [edi], ax

end_fillz:

; *********************   TEX BLIT   ************************

; Compute first left coords
; At this point
;	ESI - ptr to span
;			FPU:	; st0  st1  st2  st3  st4  st5  st6  st7
;				; 1/c  c    a    b

	fld st(3)		; b    1/c  c    a    b
	fmul st,st(1)		; v    1/c  c    a    b
	fxch st(1)		; 1/c  v    c    a    b
	fmul st,st(3)		; u    v    c    a    b
	mov ecx, [esi].spanCount
	mov edx, [esi].spanCount
	fistp [u_fixed]		; v    c    a    b
	fistp [v_fixed]		; c    a    b

; Compute 16-pix count and prerun count
	shr ecx, 4
	and edx, 0Fh
	jnz prerun_exists
	mov edx, 16
	dec ecx
prerun_exists:
	mov [run_count], ecx
	mov ecx, edx
	dec edx
	mov [temp], edx		; temp = pre-run length



; Find a,b,c at the end of the pre-run

;				  st0  st1  st2  st3  st4  st5  st6  st7
;				  c    a    b

; Advance a,b,c to the end of pre-run

	fild [temp]		; len  c    a    b
	fld [delta_a]		; da   len  c    a    b
	fmul st,st(1)		; dal  len  c    a    b
	fld [delta_b]		; db   dal  len  c    a    b
	fmul st,st(2)		; dbl  dal  len  c    a    b
	fxch st(1)		; dal  dbl  len  c    a    b
	faddp st(4),st		; dbl  len  c    a2   b
	fxch st(1)		; len  dbl  c    a2   b
	fmul [delta_c]		; dcl  dbl  c    a2   b
	fxch st(1)		; dbl  dcl  c    a2   b
	faddp st(4), st		; dcl  c    a2   b2
	faddp st(1), st		; c2   a2   b2


; Start computing 1/c for the end of pre-run
	fld [FixedOne]		; 1    c2   a2   b2
	fdiv st,st(1)		; 1/c2 c2   a2   b2

; At this point
;	ESI - ptr to span
;	ECX - pre-run pixel counter
;			FPU:	  st0  st1  st2  st3  st4  st5  st6  st7
;				  1/c  c    a    b

; Find ptr for blitting destination
	mov [span_ptr], esi	; store span for future use
	mov edi, _gfxBuffer

	mov eax, span_buf_offset
	mov esi, [u_fixed]

	add edi, eax
	mov ebp, [v_fixed]

	mov [dest_ptr], edi

; Pre-read the dest line... does it help?
;	mov al, [edi]


; !!!!!!!!!!!!!  PUT SOME INTEGER CODE IN HERE

; Find new coords
	fld st(3)		; b    1/c  c    a    b 
	fmul st,st(1)		; v    1/c  c    a    b 
	fxch st(1)		; 1/c  v    c    a    b
	fmul st,st(3)		; u    v    c    a    b

; Compute deltas. Due to the fact that pre-run has length
; different from 16, the computation is done in FPU
	fld st(1)		; v    u    v    c    a    b
	fld st(1)		; u    v    u    v    c    a    b
	fisub [u_fixed]		; u-u1 v    u    v    c    a    b
	fxch st(1)		; v    u-u1 u    v    c    a    b
	fisub [v_fixed]		; v-v1 u-u1 u    v    c    a    b
	fxch st(1)		; u-u1 v-v1 u    v    c    a    b
	fmul [inv_run+ecx*4]	; du   v-v1 u    v    c    a    b 
	fxch st(1)		; v-v1 du   u    v    c    a    b
	fmul [inv_run+ecx*4]	; dv   du   u    v    c    a    b 
	fxch st(3)		; v    du   u    dv   c    a    b
	fistp [v_fixed]		; du   u    dv   c    a    b		|
	fistp [du_fixed]	; u    dv   c    a    b			| 24!
	fistp [u_fixed]		; dv   c    a    b			|
	fistp [dv_fixed]	; c    a    b				|


; At this point
;	ECX - pre-run pixel count
;	ESI - U fixed
;	EBP - V fixed
;	du_fixed, dv_fixed - deltas for this run
;	u_fixed, v_fixed - u,v at the end of this run

; if no 16-pix runs, skip the next piece of code
	mov eax, [run_count]
	or eax, eax
	jz start_pre_run

; Advance a,b,c to the end of first 16-pix run
;				  st0  st1  st2  st3  st4  st5  st6  st7
;				  c    a    b

	fxch st(1)		; a    c    b
	fadd [delta_a16]	; a2   c    b
	fxch st(1)		; c    a2   b
	fadd [delta_c16]	; c2   a2   b
	fxch st(2)		; b    a2   c2
	fadd [delta_b16]	; b2   a2   c2
	fxch st(2)		; c    a    b

; Start computing 1/c
	fld [FixedOne]		; 1    c    a    b
	fdiv st, st(1)		; 1/c  c    a    b

; ************************  PRE-RUN BLIT  **************************

start_pre_run:

; At this point
;	ECX - pre-run pixel count
;	ESI - U fixed
;	EBP - V fixed
;	du_fixed, dv_fixed - deltas for this run
;	u_fixed, v_fixed - u,v at the end of this run

	xor edx, edx
	mov eax, [dv_fixed]	; eax = dv

	sub edx, ecx		; edx = -counter
	mov ebx, eax

	sar eax, 16		; eax = dv_int
	mov ecx, [du_fixed]	; ecx = du

	imul eax, [_pr_tex_width]

	shl ebx, 16		; ebx = dv_frac
	mov edi, ecx

	sar edi, 16		; edi = du_int
	mov [dv_frac], ebx

	shl ecx, 16		; ecx = du_frac
	add eax, edi

	mov [delta_nocarry], eax
	mov [du_frac], ecx

	add eax, [_pr_tex_width]
	mov ebx, esi		; ebx = esi = u

	sar esi, 16		; esi = u_int
	mov ecx, ebp		; ecx = ebp = v

	shl ebx, 16		; ebx = u_frac
	mov [delta_carry], eax

	sar ebp, 16		; ebp = v_int
	mov edi, [dest_ptr]

	shl ecx, 16		; ecx = v_frac
	add esi, [_pr_tex]

	imul ebp, [_pr_tex_width]

	add esi, ebp
	sub edi, edx

	mov [dest_ptr], edi


; At this point
;	EDI - dest ptr + pre_run_count
;	ESI - tex ptr at u,v
;	EBX - u frac
;	ECX - v frac
;	EDX - -counter
;	EBP - v carry scratch

; !!!  BAD CODE  !!!

pre_loop:
	add ecx, [dv_frac]
	sbb ebp,ebp
	mov al, [esi]
	add ebx, [du_frac]
	mov [edi+edx], al
	adc esi, [tex_delta+ebp*4]
	inc edx
	jnz pre_loop


; If no big runs, this span is done
	mov eax, [run_count]
	or eax, eax
	jnz span16_loop
	fld1			; 1    c    a    b
	jmp span_end


; ******************  MAIN SPAN LOOP  *******************

; At this point
;			FPU:	  st0  st1  st2  st3  st4  st5  st6  st7
;				  1/c  c    a    b
;
; FDIV should be finished (1/c - available)

span16_loop:

; Make end coords for this run
				; st0  st1  st2  st3  st4  st5  st6  st7
	fld st(2)		; a    1/c  c    a    b
	fmul st,st(1)		; u    1/c  c    a    b
	fxch st(1)		; 1/c  u    c    a    b
	fmul st,st(4)		; v    u    c    a    b

	mov esi, [u_fixed]
	mov ebp, [v_fixed]

	fistp [v_fixed]	  	; u    c    a    b
	fistp [u_fixed]	  	; c    a    b

; Setup deltas for the loop (do not use esi, ebp) and coords
	mov eax, [v_fixed]	; eax = v2
	mov ecx, [u_fixed]	; ecx = u2

	sub eax, ebp		; eax = v2-v1
	sub ecx, esi		; ecx = u2-u1

	mov ebx, eax

	sar eax, 20		; eax = dv_int
	mov edi, ecx

	imul eax, [_pr_tex_width]

	shl ebx, 12		; ebx = dv_frac

	sar edi, 20		; edi = du_int
	mov [dv_frac], ebx

	shl ecx, 12		; ecx = du_frac
	add eax, edi

	mov [delta_nocarry], eax
	mov [du_frac], ecx

	add eax, [_pr_tex_width]
	mov ebx, esi		; ebx = esi = u

	sar esi, 16		; esi = u_int
	mov ecx, ebp		; ecx = ebp = v

	shl ebx, 16		; ebx = u_frac
	mov edi, [dest_ptr]

	sar ebp, 16		; ebp = v_int
	mov [delta_carry], eax

	shl ecx, 16		; ecx = v_frac
	add esi, [_pr_tex]

	imul ebp, [_pr_tex_width]

	lea edi, [edi+16]
	add esi, ebp

	mov edx, [du_frac]
	mov [dest_ptr], edi

; At this point
;	EDI - dest ptr + 16
;	ESI - tex ptr at u,v
;	EBX - u frac
;	ECX - v frac
;	EDX - delta u frac 
;	EBP - v carry scratch


; Advance a,b,c and start fdiv for next run
	fxch st(1)		; a     c     b
	fadd [delta_a16]	; a2    c     b
	fxch st(1)		; c     a2    b
	fadd [delta_c16]	; c2    a2    b
	fxch st(2)		; b     a2    c2
	fadd [delta_b16]	; b2    a2    c2
	fxch st(2)		; c     a     b
	fld [FixedOne]		; 1     c     a     b
	fdiv st,st(1)		; 1/c   c     a     b

; Here is the main blitting loop (unrolled for 16 pixels)

	Tex16_loop

; End of the unrolled 16-pix loop

	dec dword ptr [run_count]
	jnz span16_loop


span_end:
;			FPU	; 1/c   c     a     b
	ffree st(0)
	mov esi, [span_ptr]
	ffree st(1)
	mov esi, [esi].spanNext
	ffree st(2)
	ffree st(3)

	or esi, esi
	jnz span_start


; ***********************  THE END  ************************

surf_end:


;	add esp, local_vars_size
	pop ebp
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax

        ret
_BlitTex16Surf_asm endp

end