
#include "rsoft.h"




/*
 Note about software ZBuffer:
	Its origin is the same as that of the Buffer!!!
*/

short *ZBuffer;
byte  *gfxBuffer;

Camera *ccam;


/*
  Init Z Buffer (must be called once during program init)
*/
void InitZBuffer(void)
{
	ZBuffer=malloc(gfxScrWidth*gfxScrHeight*2);
}

/*
  Free Z Buffer
*/
void ShutZBuffer(void)
{
	if (ZBuffer) free(ZBuffer);
}


int Render_GetScrWidth() {return gfxScrWidth;}
int Render_GetScrHeight() {return gfxScrHeight;}
int Render_GetFlags(void) {return 0;}


void Render_Init(int width, int height, int flags)
{
	GFX_InitGraph(width,height,flags);
	InitZBuffer();
	InitSurfCache();
	GFX_SetPalette(RGBPalette);
	Tri_Init();
}


void Render_BeginFrame(Camera *C)
{
	ccam=C;
	gfxBuffer=GFX_LockSurface(1);
}

void Render_EndFrame()
{
	GFX_UnlockSurface();
	GFX_FlipSurface();
	gfxBuffer=0;
	NumVisDLights=0;
}

void Render_Shut()
{
	ShutSurfCache();
	ShutZBuffer();
	GFX_ShutGraph();
}


