/********************************************************************
 R_SPR.C - Render Sprite
*********************************************************************/


#include "rsoft.h"



void Render_SPR(SPR *spr,POB *pob)
{
	SPRFrame *frame;
	byte *buf, *ptr, pixel;
	short *zbuf, z;
	float p[3];//, dist;
	int i,j;
	int x1,y1,x2,y2;
	int start_u, u, v, du, dv;
	float texel_width, texel_height, fx, fy;


// Xform world->camera
	XformVertex(ccam,pob->c,p);

// Do 3D trivial object reject (check against frustrum and min_z)
//	dist=spr->Header->boundingradius;
	if (p[2]<MIN_Z) return;
//	if (p[2]< p[0]-dist||p[2]< p[1]-dist) return;
//	if (p[2]<-p[0]-dist||p[2]<-p[1]-dist) return;


	frame=&spr->Frames[pob->frame];

// Project sprite coord
	ProjectVertex(ccam,p,p);

	z=(short)(p[2]*2.0*65536);

	texel_width=p[2]*ccam->proj;
	texel_height=p[2]*ccam->proj*ccam->proj_ratio;

	du=(int)(65536.0/texel_width);
	dv=(int)(65536.0/texel_height);

	fx=p[0]-texel_width*frame->origin_x;
	fy=p[1]-texel_height*frame->origin_y;

	x1=(int)fx; 
	y1=(int)fy;
	x2=(int)(fx+texel_width*frame->width);
	y2=(int)(fy+texel_height*frame->height);

	start_u=0; v=0;

// Do 2d culling
	if (x1>=ccam->width||x2<=0) return;
	if (y1>=ccam->height||y2<=0) return;

// Do 2d clipping
	if (x1<0) {
		start_u+=-x1*du;
		x1=0;
	}
	if (y1<0) {
		v+=-y1*dv;
		y1=0;
	}
	if (x2>ccam->width) x2=ccam->width;
	if (y2>ccam->height) y2=ccam->height;

// Blit the sprite
	i=(ccam->sy+y1)*gfxScrWidth+(ccam->sx+x1);
	buf =gfxBuffer+i;
	zbuf=ZBuffer+i;

	for(j=y1;j<y2;j++) {
		ptr=frame->pic+(v>>16)*frame->width;
		u=start_u;
		for(i=x1;i<x2;i++) {
			if (z>(*zbuf)) {
				pixel=ptr[u>>16];
				if (pixel!=255)	{
					*buf=pixel;
					*zbuf=z;
				}
			}
			u+=du; buf++; zbuf++;
		}
		v+=dv;
		buf+=gfxScrWidth-(x2-x1);
		zbuf+=gfxScrWidth-(x2-x1);
	}
}
