/********************************************************************
 SPR.C - Sprite support routines
*********************************************************************/

#include "engine.h"
#include "qspr.h"


int SPR_Load(SPR *spr,char *name)
{
	char fname[64];
	dsprite_t *head;
	dsprframe_t *qframe;
	SPRFrame *frame;
	int size,i,w,h;
	byte *pcx, *raw;

// Open sprite file
	strcpy(fname,name);

// Read the file
	raw=(byte *)DAT_ReadFile(fname,&size);

// Make Header pointer
	head=(dsprite_t *)raw;

// Check file type and version
	if (head->ident!=IDSPRITEHEADER||
	    head->version!=SPRITE_VERSION) {
		free(raw);
		return 0;
	}

// Set sprite info
	spr->NumFrames=head->numframes;
	strcpy(spr->Name,name);

// Make pointer to frames
	frame=spr->Frames;
	qframe=head->frames;

// Allocate and load pics

	for(i=0;i<spr->NumFrames;i++,frame++,qframe++) {
		memcpy(fname,qframe->name,64);
		fname[63]='\0';
		pcx = DAT_ReadFile(fname,&size);
		if (pcx) {
			frame->pic=PCX_Decode(pcx,&w,&h,frame->pal);
			free(pcx);
			strcpy(frame->name,fname);
			frame->width=qframe->width;
			frame->height=qframe->height;
			frame->origin_x=qframe->origin_x;
			frame->origin_y=qframe->origin_y;
			frame->is_rgba=0;
		}
	}

// Clean up
	free(raw);

	return 1;
}

void SPR_Free(SPR *spr)
{
	int i;

	for(i=0;i<spr->NumFrames;i++)
		free(spr->Frames[i].pic);
	spr->NumFrames=0;
}
