
#include "engine.h"
#include "render.h"


/**
 Command line params
*/

static char *cmd_ptr;

void cmd_init(char *params)
{
        cmd_ptr=params;
}

char *cmd_next() {
        char *ptr=cmd_ptr;

        if (cmd_ptr!=0) {
                while(cmd_ptr[0]!='\0'&&cmd_ptr[0]!=' ')
                        cmd_ptr++;
                if (cmd_ptr[0]=='\0') {
                        if (ptr==cmd_ptr) ptr=0;
                        cmd_ptr=0;
                }
                else {cmd_ptr[0]='\0';cmd_ptr++;}
        }

        return(ptr);
}


/**
 The program entry point
*/

EngineImport eimp;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	int w=0, h=0;
	char *param;
	char bsp_name[64]="base1.bsp";


// Setup EngineImport structure
	eimp.hInstance=hInstance;
	strcpy(eimp.dataPath,"f:\\quake2\\baseq2\\");

// Init both server and client
	eimp.mode=ENGINE_SERVER|ENGINE_CLIENT;

// Setup client params
	eimp.renderWidth=640;
	eimp.renderHeight=480;
	eimp.renderFlags=0;


// Start processing command-line params
	cmd_init(szCmdLine);
	while((param=cmd_next())!=0) {
		if (strcmp(param,"-pak")==0) {
			if ((param=cmd_next())!=0)
				strcpy(eimp.dataPath,param);
		}
		else if (strcmp(param,"-win")==0) {
			eimp.renderFlags|=R_WINDOWED;
			if ((param=cmd_next())!=0)
				sscanf(param,"%d",&w);
			if ((param=cmd_next())!=0)
				sscanf(param,"%d",&h);
		}
		else if (strcmp(param,"-gfx")==0) {
			if ((param=cmd_next())!=0)
				sscanf(param,"%d",&w);
			if ((param=cmd_next())!=0)
				sscanf(param,"%d",&h);
		}
		else if (param[0]!='-') {
			strcpy(bsp_name,param);
		}
	}

	if (w>0) eimp.renderWidth=w;
	if (h>0) eimp.renderHeight=h;

// Init the engine
	Engine_Init(&eimp);

// !!! If you've setup a server you must call this !!!
	if (Engine_IsServer()) Server_NewWorld(bsp_name);

// The main game loop
	while(!Done) {
		Engine_NextFrame();
	}

// Shutdown the engine
	Engine_Shut();

	return(0);
}


